#include "../src/main.h"

typedef unsigned char UBYTE;
typedef short objectType;

#define USE_SPECIAL_BD_ELEMENTS		TRUE

#include "convertlevel_boulderdash.h"

#if defined(LEVEL_SERIES_BD1)
#include "../Resources/BoulderDashWebArchive/bd-levels/cavedata-bd1.h"
#define MAX_LEVELS	20
#elif defined(LEVEL_SERIES_BD2)
#include "../Resources/BoulderDashWebArchive/bd-levels/cavedata-bd2.h"
#define MAX_LEVELS	80
#elif defined(LEVEL_SERIES_BD16)
#include "../Resources/BoulderDashWebArchive/bd-levels/cavedata-bd16.h"
#define MAX_LEVELS	200
#else
#include "../Resources/BoulderDashWebArchive/cavedata.h"
#define MAX_LEVELS	20
#endif

#define LEVEL_COOKIE            "ROCKSNDIAMONDS_LEVEL_FILE_VERSION_1.0"
#define NUM_FREE_LVHD_BYTES     18
#define LEVEL_PERMS     (S_IRUSR|S_IWUSR | S_IRGRP|S_IWGRP | S_IROTH|S_IWOTH)
#define SC_EDELSTEIN            0

unsigned char *cave_array[MAX_LEVELS] =
{
  cave1, cave2, cave3, cave4, cave5,
  cave6, cave7, cave8, cave9, cave10,
  cave11, cave12, cave13, cave14, cave15,
  cave16, cave17, cave18, cave19, cave20,

#if defined(LEVEL_SERIES_BD2) || defined(LEVEL_SERIES_BD16)
  cave21, cave22, cave23, cave24, cave25,
  cave26, cave27, cave28, cave29, cave30,
  cave31, cave32, cave33, cave34, cave35,
  cave36, cave37, cave38, cave39, cave40,
  cave41, cave42, cave43, cave44, cave45,
  cave46, cave47, cave48, cave49, cave50,
  cave51, cave52, cave53, cave54, cave55,
  cave56, cave57, cave58, cave59, cave60,
  cave61, cave62, cave63, cave64, cave65,
  cave66, cave67, cave68, cave69, cave70,
  cave71, cave72, cave73, cave74, cave75,
  cave76, cave77, cave78, cave79, cave80,
#endif

#if defined(LEVEL_SERIES_BD16)
  cave81, cave82, cave83, cave84, cave85,
  cave86, cave87, cave88, cave89, cave90,
  cave91, cave92, cave93, cave94, cave95,
  cave96, cave97, cave98, cave99, cave100,
  cave101, cave102, cave103, cave104, cave105,
  cave106, cave107, cave108, cave109, cave110,
  cave111, cave112, cave113, cave114, cave115,
  cave116, cave117, cave118, cave119, cave120,
  cave121, cave122, cave123, cave124, cave125,
  cave126, cave127, cave128, cave129, cave130,
  cave131, cave132, cave133, cave134, cave135,
  cave136, cave137, cave138, cave139, cave140,
  cave141, cave142, cave143, cave144, cave145,
  cave146, cave147, cave148, cave149, cave150,
  cave151, cave152, cave153, cave154, cave155,
  cave156, cave157, cave158, cave159, cave160,
  cave161, cave162, cave163, cave164, cave165,
  cave166, cave167, cave168, cave169, cave170,
  cave171, cave172, cave173, cave174, cave175,
  cave176, cave177, cave178, cave179, cave180,
  cave181, cave182, cave183, cave184, cave185,
  cave186, cave187, cave188, cave189, cave190,
  cave191, cave192, cave193, cave194, cave195,
  cave196, cave197, cave198, cave199, cave200
#endif

};

void LoadBDLevel(int, int);
void SaveNewLevel(char *);

/* Prototypes */
void DecodeCave(UBYTE *aCaveData, int difficulty);
void StoreObject(int x, int y, objectType anObject);
void DrawLine(objectType anObject, int x, int y, int aLength, int aDirection);
void DrawFilledRect(objectType anObject, int x, int y, int aWidth, int aHeight, objectType aFillObject);
void DrawRect(objectType anObject, int x, int y, int aWidth, int aHeight);
void NextRandom(int *RandSeed1, int *RandSeed2);

struct LevelInfo level;
short Ur[MAX_LEV_FIELDX][MAX_LEV_FIELDY];

char *progname;

#define BD_LEV_FIELDX	40
#define BD_LEV_FIELDY	22

void LoadBDLevel(int levelnr, int difficulty)
{
  int i,x,y;
  boolean spieler = FALSE;
  boolean ausgang = FALSE;
  boolean amoebe = FALSE, muehle = FALSE;

  printf("Decoding BoulderDash level %d / difficulty %d\n",
	 levelnr, difficulty);

  /* Start with default values */
  level.fieldx = STD_LEV_FIELDX;
  level.fieldy = STD_LEV_FIELDY;
  level.time		= 100;
  level.gems_needed	= 0;
  for(i=0;i<MAX_LEVEL_NAME_LEN;i++)
    level.name[i] = 0;
  strncpy(level.name,"Nameless BoulderDash Level",MAX_LEVEL_NAME_LEN-1);
  for(i=0;i<LEVEL_SCORE_ELEMENTS;i++)
    level.score[i]	= 10;
  for(i=0;i<4;i++)
    for(y=0;y<3;y++)
      for(x=0;x<3;x++)
#if USE_SPECIAL_BD_ELEMENTS
	level.yam_content[i][x][y] = EL_BD_ROCK;
#else
	level.yam_content[i][x][y] = EL_FELSBROCKEN;
#endif
  level.amoeba_speed	= 10;
  level.time_magic_wall	= 10;
  level.time_wheel	= 10;
  level.amoeba_content = EL_EDELSTEIN_BD;

  for(y=0;y<level.fieldy;y++) 
    for(x=0;x<level.fieldx;x++) 
      Ur[x][y] = EL_ERDREICH;
  Ur[0][0] = EL_SPIELFIGUR;
  Ur[level.fieldx-1][level.fieldy-1] = EL_AUSGANG_ZU;

  /* Read level to Ur[][] */
  DecodeCave(cave_array[levelnr-1], difficulty);

  for(y=0;y<level.fieldy;y++) 
    for(x=0;x<level.fieldx;x++) 
      Ur[x][y] = Ur[x][y+2];

  for(y=0;y<level.fieldy;y++) 
  {
    for(x=0;x<level.fieldx;x++) 
    {
      if (Ur[x][y] == EL_SPIELFIGUR)
	spieler = TRUE;
      if (Ur[x][y] == EL_AUSGANG_ZU || Ur[x][y] == EL_AUSGANG_AUF)
	ausgang = TRUE;
      if (Ur[x][y] == EL_AMOEBE_BD)
	amoebe = TRUE;
      if (Ur[x][y] == EL_MAGIC_WALL_BD_OFF)
	muehle = TRUE;

#if USE_SPECIAL_BD_ELEMENTS
#define AUS_STEIN(x) ((x) == EL_BETON || (x) == EL_MAUERWERK || (x) == EL_MAUER_LEBT || (x) == EL_BD_WALL)
#else
#define AUS_STEIN(x) ((x) == EL_BETON || (x) == EL_MAUERWERK || (x) == EL_MAUER_LEBT || (x) == EL_FELSBODEN)
#endif

      if (Ur[x][y] == EL_MAUERWERK &&
	  y>0 && !AUS_STEIN(Ur[x][y-1]) &&
	  ((x>0 && !AUS_STEIN(Ur[x-1][y])) ||
	   (x<level.fieldx-1 && !AUS_STEIN(Ur[x+1][y])) ))
#if USE_SPECIAL_BD_ELEMENTS
	Ur[x][y] = EL_BD_WALL;
#else
	Ur[x][y] = EL_FELSBODEN;
#endif
    }
  }

  if (!spieler)
  {
    printf("%s: No player in this level!\n",
           progname);
    exit(0);
  }

  if (!ausgang)
  {
    printf("%s: No exit in this level!\n",
           progname);
    exit(0);
  }

  if (amoebe)
  {
    level.time_magic_wall = 0;
    level.amoeba_speed = BD_TEMPO_AMOEBE;
  }

  if (muehle)
    level.amoeba_speed = 0;
}

void SaveNewLevel(char *filename)
{
  int i,x,y;
  FILE *file;

  printf("Writing '%s'\n",filename);

  if (!(file=fopen(filename,"w")))
  {
    fprintf(stderr,"%s: cannot save level file '%s'!\n",progname,filename);
    return;
  }

  fputs(LEVEL_COOKIE,file);		/* Formatkennung */
  fputc(0x0a,file);

  fputc(level.fieldx,file);
  fputc(level.fieldy,file);
  fputc(level.time / 256,file);
  fputc(level.time % 256,file);
  fputc(level.gems_needed / 256,file);
  fputc(level.gems_needed % 256,file);

  for(i=0;i<MAX_LEVEL_NAME_LEN;i++)
    fputc(level.name[i],file);
  for(i=0;i<LEVEL_SCORE_ELEMENTS;i++)
    fputc(level.score[i],file);
  for(i=0;i<4;i++)
    for(y=0;y<3;y++)
      for(x=0;x<3;x++)
	fputc(level.yam_content[i][x][y],file);
  fputc(level.amoeba_speed,file);
  fputc(level.time_magic_wall,file);
  fputc(level.time_wheel,file);
  fputc(level.amoeba_content,file);

  for(i=0;i<NUM_FREE_LVHD_BYTES;i++)	/* Rest frei / Headergre 80 Bytes */
    fputc(0,file);

  for(y=0;y<level.fieldy;y++) 
    for(x=0;x<level.fieldx;x++) 
      fputc(Ur[x][y],file);

  fclose(file);

  chmod(filename, LEVEL_PERMS);
}

/*---------------------------------------------------------------------------*/
/* derived code from "BoulderDashWebArchive/decodecaves.c"                   */
/*---------------------------------------------------------------------------*/

void DecodeCave(UBYTE *aCaveData, int difficulty)
{
  int RandSeed1, RandSeed2;
  int theWidth, theHeight, theFill, theLength, theDirection;
  int x, y;
  int caveDataIndex;
  objectType theObject;
  int theCode;

#if defined(LEVEL_SERIES_BD2) || defined(LEVEL_SERIES_BD16)
  int season = difficulty + 1;
  difficulty = 0;
#endif

  RandSeed1 = 0;
  RandSeed2 = aCaveData[4 + difficulty];

  if (aCaveData[0] <= 16)
  {
#if defined(LEVEL_SERIES_BD2) || defined(LEVEL_SERIES_BD16)
    sprintf(level.name, "Season %d: Cave %c",
	    season, aCaveData[0]+'A'-1);
#else
    sprintf(level.name, "%s (%s)",
	    caveNames[aCaveData[0]-1], caveDifficulty[difficulty]);
#endif

    level.fieldx = BD_LEV_FIELDX;
    level.fieldy = BD_LEV_FIELDY;
  }
  else
  {
#if defined(LEVEL_SERIES_BD2) || defined(LEVEL_SERIES_BD16)
    sprintf(level.name, "Season %d: Intermission %d",
	    season, aCaveData[0]-16);
#else
    sprintf(level.name, "Intermission %d (%s)",
	    aCaveData[0]-16, caveDifficulty[difficulty]);
#endif

    level.fieldx = BD_LEV_FIELDX - 20;
    level.fieldy = BD_LEV_FIELDY - 10;
  }

  level.gems_needed = aCaveData[9 + difficulty];
  level.score[SC_EDELSTEIN] = aCaveData[2];
  level.time = aCaveData[14 + difficulty] + 10;
  level.time_magic_wall = aCaveData[1];
  level.amoeba_speed = aCaveData[1];

  for(x = 0; x < 40; x++)
    for (y = 0; y <= 22; y++)
      Ur[x][y] = EL_BETON;

  /* Decode the random cave data */
  for(y = 3; y <= 22; y++)
  {
    for(x = 0; x <= 39; x++)
    {
      theObject = EL_ERDREICH;
      NextRandom(&RandSeed1, &RandSeed2);
      for (caveDataIndex = 0; caveDataIndex <= 3; caveDataIndex++)
	if (RandSeed1 < aCaveData[0x1C + caveDataIndex])
	  theObject = aCaveData[0x18 + caveDataIndex];

      StoreObject(x, y, theObject);
    }     
  }  

  /* SteelBounds */
  DrawRect(0x07, 0, 2, 40, 22);

  /* Decode the explicit cave data */
  for (caveDataIndex = 0x20; aCaveData[caveDataIndex] != 0xFF; caveDataIndex++)
  {
    theCode = aCaveData[caveDataIndex];
    theObject = theCode & 0x3F;

    switch(3 & (aCaveData[caveDataIndex] >> 6))
    {
      case 0: /* PLOT */
        x = aCaveData[++caveDataIndex];
	y = aCaveData[++caveDataIndex];
	StoreObject(x, y, theObject);
	break;

      case 1: /* LINE */
	x = aCaveData[++caveDataIndex];
	y = aCaveData[++caveDataIndex];
	theLength = aCaveData[++caveDataIndex];
	theDirection = aCaveData[++caveDataIndex];
	DrawLine(theObject, x, y, theLength, theDirection);
	break;

      case 2: /* FILLED RECTANGLE */
	x = aCaveData[++caveDataIndex];
	y = aCaveData[++caveDataIndex];
	theWidth = aCaveData[++caveDataIndex];
	theHeight = aCaveData[++caveDataIndex];
	theFill = aCaveData[++caveDataIndex];
	DrawFilledRect(theObject, x, y, theWidth, theHeight, theFill);
	break;

      case 3: /* OPEN RECTANGLE */
	x = aCaveData[++caveDataIndex];
	y = aCaveData[++caveDataIndex];
	theWidth = aCaveData[++caveDataIndex];
	theHeight = aCaveData[++caveDataIndex];
	DrawRect(theObject, x, y, theWidth, theHeight);
	break;
      }
  }
}



/* **************************************** */
void StoreObject(int x, int y, objectType anObject)
{
  Ur[x][y] = creatureCode[anObject];
}



/* **************************************** */
void DrawLine(objectType anObject, int x, int y, int aLength, int aDirection)
{
  /* Local variables */
  int counter;

  for(counter = 1; counter <= aLength; counter++) {
    StoreObject(x, y, anObject);
    x += ldx[aDirection];
    y += ldy[aDirection];
  }
}



/* **************************************** */
void DrawFilledRect(objectType anObject, int x, int y, int aWidth, int aHeight, objectType aFillObject)
{
  /* Local variables */
  int counter1;
  int counter2;

  for(counter1 = 0; counter1 < aWidth; counter1++) {
    for(counter2 = 0; counter2 < aHeight; counter2++) {
      if ((counter1 == 0) || (counter1 == aWidth-1)) {
	StoreObject(x+counter1, y+counter2, anObject);
      } else {
	StoreObject(x+counter1, y+counter2, aFillObject);
      }
    }
    StoreObject(x+counter1, y, anObject);
    StoreObject(x+counter1, y+aHeight-1, anObject);
  }
}



/* **************************************** */
void DrawRect(objectType anObject, int x, int y, int aWidth, int aHeight)
{
  /* Local variables */
  int counter1;

  for(counter1 = 0; counter1 < aWidth; counter1++) {
    StoreObject(x + counter1, y, anObject);
    StoreObject(x + counter1, y + aHeight-1, anObject);
  }
  for(counter1 = 0; counter1 < aHeight; counter1++) {
    StoreObject(x, y + counter1, anObject);
    StoreObject(x + aWidth-1, y + counter1, anObject);
  }
}



/* **************************************** */
void NextRandom(int *RandSeed1, int *RandSeed2)
/* This is the mathematical random number generator from the Commodore 64
   implementation of Boulder Dash I. The 6510 disassembly is given in
   comments, and the C translation follows. */
{
    short TempRand1;
    short TempRand2;
    short carry;
    short result;


/*
            7085 NextRandom.00  LDA RandSeed1
            7087                ROR
            7088                ROR
            7089                AND #$80
            708B                STA TempRand1
        
            Note: ROR on the 6510 works like this:
              7-->6-->5-->4-->3-->2-->1-->0-->C
              ^                               |
              |_______________________________|
            In other words, it's a nine-bit rotate. Thus it takes two RORs to shift
            the low bit (bit zero) into the high bit (bit 7).
*/
    TempRand1 = (*RandSeed1 & 0x0001) * 0x0080;	/* Bugfix! */


        /*
            708E                LDA RandSeed2
            7090                ROR
            7091                AND #$7F
            7093                STA TempRand2
        */
    TempRand2 = (*RandSeed2 >> 1) & 0x007F;


        /*
            7096                LDA RandSeed2
            7098                ROR
            7099                ROR
            709A                AND #$80
            709C                CLC
            709D                ADC RandSeed2
        */
    result = (*RandSeed2) + (*RandSeed2 & 0x0001) * 0x0080;
    carry = (result > 0x00FF);
    result = result & 0x00FF;


        /*
            709F                ADC #$13
            70A1                STA RandSeed2
        */
    result = result + carry + 0x13;
    carry = (result > 0x00FF);
    *RandSeed2 = result & 0x00FF;


        /*
            70A3                LDA RandSeed1
            70A5                ADC TempRand1
        */
    result = *RandSeed1 + carry + TempRand1;
    carry = (result > 0x00FF);
    result = result & 0x00FF;


        /*
            70A8                ADC TempRand2
            70AB                STA RandSeed1
            70AD                RTS
        */
    result = result + carry + TempRand2;
    *RandSeed1 = result & 0x00FF;

}

/* ------------------------------------------------------------------------- */
/* main program                                                              */
/* ------------------------------------------------------------------------- */

void main(int argc, char *argv[])
{
  int levelnr, difficulty, max_difficulty;
  int leveldata_nr, leveldifficulty;
  int level[20] =
  {	
    1,2,3,4,	 17,
    5,6,7,8,	 18,
    9,10,11,12,	 19,
    13,14,15,16, 20
  };

#if defined(LEVEL_SERIES_BD2) || defined(LEVEL_SERIES_BD16)
  max_difficulty = 1;
#else
  max_difficulty = 5;
#endif

  progname = argv[0];

  if (argc != 2)
  {
    printf("Usage: %s <new level directory>\n", progname);
    exit(0);
  }

  for(difficulty = 0; difficulty < max_difficulty; difficulty++)
  {
    for(levelnr = 0; levelnr < MAX_LEVELS; levelnr++)
    {
      char levelfile_new[50];
      sprintf(levelfile_new, "%s/%03d.level",
	      argv[1], difficulty * MAX_LEVELS + levelnr);

#if defined(LEVEL_SERIES_BD2) || defined(LEVEL_SERIES_BD16)
      leveldata_nr = level[levelnr % 20] + (levelnr / 20) * 20;
      leveldifficulty = levelnr / 20;
#else
      leveldata_nr = level[levelnr];
      leveldifficulty = difficulty;
#endif

      LoadBDLevel(leveldata_nr, leveldifficulty);
      SaveNewLevel(levelfile_new);
    }
  }
}
