/*
#include "main-1.1b.h"
*/

#include "../src/main.h"
#include "../src/game.h"

#define EL_UNKNOWN_EL		-999

struct LevelInfo level;
short Ur[MAX_LEV_FIELDX][MAX_LEV_FIELDY];

char *progname;

static void setLevelInfoToDefaults();

int lev_fieldx, lev_fieldy;

int map_em_element_yam(int element)
{
  switch (element)
  {
    case 0x00:	return EL_LEERRAUM;
    case 0x01:	return EL_EDELSTEIN;
    case 0x02:	return EL_DIAMANT;
    case 0x03:	return EL_FELSBROCKEN;
    case 0x04:	return EL_ROBOT;
    case 0x05:	return EL_FLIEGER_UP;
    case 0x06:	return EL_BOMBE;
    case 0x07:	return EL_KAEFER_UP;
    case 0x08:	return EL_TROPFEN;
    case 0x09:	return EL_KOKOSNUSS;
    case 0x0a:	return EL_MAMPFER;
    case 0x0b:	return EL_MORAST_VOLL;
    case 0x0c:	return EL_ERDREICH;
    case 0x0d:	return EL_FELSBODEN;
    case 0x0e:	return EL_BETON;
    case 0x0f:	return EL_MAUERWERK;
    case 0x10:	return EL_EM_KEY_1_FILE;
    case 0x11:	return EL_EM_KEY_2_FILE;
    case 0x12:	return EL_EM_KEY_4_FILE;
    case 0x13:	return EL_EM_KEY_3_FILE;
    case 0x14:	return EL_MAGIC_WALL_OFF;
    case 0x15:	return EL_ABLENK_AUS;
    case 0x16:	return EL_DYNAMITE_INACTIVE;

    case 0x17:	return EL_EM_KEY_1_FILE;	/* EMC */
    case 0x18:	return EL_KAEFER_UP;		/* EMC */
    case 0x1a:	return EL_DIAMANT;		/* EMC */
    case 0x1b:	return EL_EDELSTEIN;		/* EMC */
    case 0x25:	return EL_KOKOSNUSS;		/* EMC */
    case 0x80:	return EL_LEERRAUM;		/* EMC */
    case 0x85:	return EL_EM_KEY_1_FILE;	/* EMC */
    case 0x86:	return EL_EM_KEY_2_FILE;	/* EMC */
    case 0x87:	return EL_EM_KEY_4_FILE;	/* EMC */
    case 0x88:	return EL_EM_KEY_3_FILE;	/* EMC */
    case 0x94:	return EL_MORAST_LEER;		/* EMC */
    case 0x9a:	return EL_AMOEBE_NASS;		/* EMC */
    case 0xaf:	return EL_DYNAMITE_INACTIVE;	/* EMC */
    case 0xbd:	return EL_ERDREICH;		/* EMC */

    default:	return EL_UNKNOWN_EL;
  }
}

int map_em_element_field(int element)
{
  if (element >= 0xc8 && element <= 0xe1)	/* Buchstaben A bis Z */
    return EL_CHAR_A + (element - 0xc8);
  else if (element >= 0xe2 && element <= 0xeb)	/* Zahlen 0 bis 9 */
    return EL_CHAR_0 + (element - 0xe2);

  switch (element)
  {
    case 0x00:	return EL_FELSBROCKEN;
    case 0x02:	return EL_DIAMANT;
    case 0x03:	return EL_DIAMANT;
    case 0x04:	return EL_ROBOT;
    case 0x05:	return EL_ROBOT;		/* EMC */
    case 0x08:	return EL_FLIEGER_UP;
    case 0x09:	return EL_FLIEGER_RIGHT;
    case 0x0a:	return EL_FLIEGER_DOWN;
    case 0x0b:	return EL_FLIEGER_LEFT;
    case 0x0c:	return EL_FLIEGER_UP;
    case 0x0d:	return EL_FLIEGER_RIGHT;
    case 0x0e:	return EL_FLIEGER_DOWN;
    case 0x0f:	return EL_FLIEGER_LEFT;
    case 0x10:	return EL_BOMBE;
    case 0x12:	return EL_EDELSTEIN;
    case 0x13:	return EL_EDELSTEIN;
    case 0x14:	return EL_KAEFER_UP;
    case 0x15:	return EL_KAEFER_RIGHT;
    case 0x16:	return EL_KAEFER_DOWN;
    case 0x17:	return EL_KAEFER_LEFT;
    case 0x18:	return EL_KAEFER_UP;
    case 0x19:	return EL_KAEFER_RIGHT;
    case 0x1a:	return EL_KAEFER_DOWN;
    case 0x1b:	return EL_KAEFER_LEFT;
    case 0x1c:	return EL_TROPFEN;
    case 0x20:	return EL_FELSBROCKEN;
    case 0x24:	return EL_MAGIC_WALL_OFF;
    case 0x25:	return EL_KOKOSNUSS;
    case 0x28:	return EL_ABLENK_AUS;		/* EMC;
						   looks like magic wheel,
						   but is _always_ activated */
    case 0x29:	return EL_MAMPFER;
    case 0x2a:	return EL_MAMPFER;
    case 0x2b:	return EL_MAMPFER;		/* EMC */
    case 0x2c:	return EL_MAMPFER;		/* EMC */
    case 0x2d:	return EL_MORAST_VOLL;
    case 0x39:	return EL_MAUER_X;		/* EMC */
    case 0x3a:	return EL_MAUER_Y;		/* EMC */
    case 0x3b:	return EL_DYNAMITE_ACTIVE;
    case 0x3c:	return EL_DYNAMITE_ACTIVE;
    case 0x3d:	return EL_DYNAMITE_ACTIVE;
    case 0x3e:	return EL_DYNAMITE_ACTIVE;
    case 0x3f:	return EL_BADEWANNE4;
    case 0x40:	return EL_AUSGANG_AUF;
    case 0x41:	return EL_AUSGANG_AUF;
    case 0x42:	return EL_AUSGANG_AUF;
    case 0x43:	return EL_BALLOON;
    case 0x4e:	return EL_UNSICHTBAR;
    case 0x65:	return EL_SALZSAEURE;		/* EMC */
    case 0x73:	return EL_ERDREICH;		/* EMC */
    case 0x74:	return EL_BETON;
    case 0x7b:	return EL_SALZSAEURE;
    case 0x80:	return EL_LEERRAUM;
    case 0x81:	return EL_FELSBODEN;
    case 0x82:	return EL_ERDREICH;
    case 0x83:	return EL_BETON;
    case 0x84:	return EL_MAUERWERK;
    case 0x85:	return EL_EM_KEY_1_FILE;
    case 0x86:	return EL_EM_KEY_2_FILE;
    case 0x87:	return EL_EM_KEY_4_FILE;
    case 0x88:	return EL_EM_KEY_3_FILE;
    case 0x89:	return EL_EM_GATE_1;
    case 0x8a:	return EL_EM_GATE_2;
    case 0x8b:	return EL_EM_GATE_4;
    case 0x8c:	return EL_EM_GATE_3;
    case 0x8d:	return EL_UNSICHTBAR;		/* EMC */
    case 0x8e:	return EL_EM_GATE_1X;
    case 0x8f:	return EL_EM_GATE_2X;
    case 0x90:	return EL_EM_GATE_4X;
    case 0x91:	return EL_EM_GATE_3X;
    case 0x92:	return EL_MAGIC_WALL_OFF;
    case 0x94:	return EL_MORAST_LEER;
    case 0x95:	return EL_BADEWANNE1;
    case 0x96:	return EL_BADEWANNE2;
    case 0x97:	return EL_BADEWANNE3;
    case 0x98:	return EL_BADEWANNE5;
    case 0x99:	return EL_SALZSAEURE;
    case 0x9a:	return EL_AMOEBE_TOT;
    case 0x9b:	return EL_AMOEBE_TOT;
    case 0x9c:	return EL_AMOEBE_TOT;
    case 0x9d:	return EL_AMOEBE_TOT;
    case 0x9e:	return EL_AUSGANG_ZU;
    case 0x9f:	return EL_CHAR_LT;		/* EMC */
    case 0x93:	return EL_ABLENK_AUS;
    case 0xa0:	return EL_MAUERWERK;		/* EMC;
						   looks like normal dust,
						   but behaves like wall */
    case 0xa8:	return EL_EMC_WALL_1;		/* EMC */
    case 0xa9:	return EL_EMC_WALL_2;		/* EMC */
    case 0xaa:	return EL_EMC_WALL_3;		/* EMC */
    case 0xab:	return EL_EMC_WALL_7;		/* EMC */
    case 0xae:	return EL_CHAR_MINUS;		/* EMC */
    case 0xaf:	return EL_DYNAMITE_INACTIVE;
    case 0xb0:	return EL_EMC_STEEL_WALL_1;	/* EMC */
    case 0xb1:	return EL_EMC_WALL_8;		/* EMC */
    case 0xb3:	return EL_BETON;		/* EMC (exact steel wall) */
    case 0xb4:	return EL_FELSBODEN;		/* EMC */
    case 0xb5:	return EL_EMC_WALL_6;		/* EMC */
    case 0xb6:	return EL_EMC_WALL_5;		/* EMC */
    case 0xb7:	return EL_EMC_WALL_4;		/* EMC */
    case 0xb8:	return EL_BALLOON_SEND_ANY;	/* EMC */
    case 0xb9:	return EL_BALLOON_SEND_RIGHT;	/* EMC */
    case 0xba:	return EL_BALLOON_SEND_DOWN;	/* EMC */
    case 0xbb:	return EL_BALLOON_SEND_LEFT;	/* EMC */
    case 0xbc:	return EL_BALLOON_SEND_UP;	/* EMC */
    case 0xbd:	return EL_ERDREICH;		/* EMC */
    case 0xec:	return EL_CHAR_PUNKT;
    case 0xed:	return EL_CHAR_AUSRUF;
    case 0xee:	return EL_CHAR_DOPPEL;
    case 0xef:	return EL_CHAR_FRAGE;
    case 0xf0:	return EL_CHAR_GT;
    case 0xf1:	return EL_CHAR_COPY;
    case 0xfe:	return EL_SPIELER1;
    case 0xff:	return EL_SPIELER2;

    default:	return EL_UNKNOWN_EL;
  }
}

void LoadEmeraldMineLevel(char *filename, int level_nr)
{
  int i,x,y;
  FILE *file;
  int JX,JY;
  unsigned char body[40][64];
  unsigned char *leveldata = &body[0][0];
  unsigned char *header = &leveldata[2048];
  unsigned char code0 = 0x65;
  unsigned char code1 = 0x11;
  boolean level_is_crypted = FALSE;

  /* always start with reliable default values */
  setLevelInfoToDefaults();

  printf("|  Reading '%s'\n", filename);

  if (!(file = fopen(filename ,"r")))
  {
    fprintf(stderr,"%s: cannot load level %s!\n",
	    progname,filename);
    return;
  }

  for(i=0;i<2106;i++)
    leveldata[i] = fgetc(file);
  fclose(file);

  /* Guess-If-Level-Is-Crypted Method 1:
     try to guess if this level is crypted or not by taking the fact
     that the first row is normally built from the same element
     (normally steel wall); do not compare with the edge elements
     which might be special elements; also skip leveldata[1],
     which might have a special meaning, too (see below).

     Guess-If-Level-Is-Crypted Method 2:
     Directly check the known starting bytes of the few crypted levels
     (from Emerald Mine 1 + 2)
  */

#if 0
  if (leveldata[2] != leveldata[3] ||
      leveldata[3] != leveldata[4] ||
      leveldata[4] != leveldata[5])
  {
    level_is_crypted = TRUE;

    fprintf(stderr, "NOTE: Level %d seems to be crypted -- decrypting...\n",
	    level_nr);
  }
#else
  if ((leveldata[0] == 0xf1 || leveldata[0] == 0xf5) &&
      leveldata[2] == 0xe7 && leveldata[3] == 0xee)
  {
    level_is_crypted = TRUE;

    if (leveldata[0] == 0xf5)	/* error in crypted Emerald Mine 2 levels */
      leveldata[0] = 0xf1;

    fprintf(stderr, "NOTE: Level %d seems to be crypted -- decrypting...\n",
	    level_nr);
  }
#endif

  if (level_is_crypted)		/* decode crypted level data */
  {
    for(i=0;i<2106;i++)
    {
      leveldata[i] ^= code0;
      leveldata[i] -= code1;
      code0  = (code0 + 7) % 256;
    }
  }

  lev_fieldx = level.fieldx	= 64;
  lev_fieldy = level.fieldy	= 32;
  level.time			= header[46]*10;
  level.gems_needed		= header[47];

  level.num_yam_contents = 4;

#if 0
  /* The original Emerald Mine levels have their level number stored
     at the second byte of the level file...
     Do not trust this information at other level files, e.g. EMC,
     but correct it anyway (normally the first row is completely
     steel wall, so the correction does not hurt anyway).
  */
  level_nr = leveldata[1];		/* get level number from level data */
#endif

  leveldata[1] = leveldata[2];		/* correct level number field */

  for(i=0;i<MAX_LEVEL_NAME_LEN;i++)
    level.name[i] = 0;

  /*
  sprintf(level.name,"Emerald Mine Level %d",level_nr);
  */

  sprintf(level.name,"Level %d",level_nr);

  for(i=0;i<LEVEL_SCORE_ELEMENTS;i++)
    level.score[i]		= 10;
  level.score[SC_EDELSTEIN]	= header[36];
  level.score[SC_DIAMANT]	= header[37];
  level.score[SC_ROBOT]		= header[38];
  level.score[SC_FLIEGER]	= header[39];
  level.score[SC_KAEFER]	= header[40];
  level.score[SC_MAMPFER]	= header[41];
  level.score[SC_KOKOSNUSS]	= header[42];
  level.score[SC_DYNAMIT]	= header[43];
  level.score[SC_ZEITBONUS]	= header[44];

  JX = header[48]*256+header[49] % 64;
  JY = header[48]*256+header[49] / 64;

  for(i=0;i<4;i++) for(y=0;y<3;y++) for(x=0;x<3;x++)
  {
    int element = header[i*9+y*3+x];
    int new_element;

    new_element = map_em_element_yam(element);

    if (new_element == EL_UNKNOWN_EL)
    {
      printf("----------> Oops! [%d][%d][%d]: element 0x%02x unknown!\n",
	     i,x,y,element);

      new_element = EL_CHAR_FRAGE;
    }
    else if (new_element >= EL_FIRST_RUNTIME_EL)
    {
      printf("----------> Oops! GOT RUNTIME ELEMENT! SHOULD NEVER HAPPEN!\n");

      new_element = EL_CHAR_FRAGE;
    }

    level.yam_content[i][x][y] = new_element;
  }

/*
  printf("Zeit:   %ld\n",header[46]);
  printf("Ambe:  %ld\n",header[52]*256+header[53]);
  printf("Sieb:   %ld\n",header[54]*256+header[55]);
  printf("Ablenk: %ld\n",header[56]*256+header[57]);
*/

  level.amoeba_speed		= (header[52]*256+header[53]) % 256;
  level.time_magic_wall		= (header[54]*256+header[55]) * 16 / 100;
  level.time_wheel		= (header[56]*256+header[57]) * 16 / 100;
  level.amoeba_content		= EL_DIAMANT;

  for(y=0;y<32;y++) for(x=0;x<64;x++)
  {
    int element = body[y][x];
    int new_element;

    new_element = map_em_element_field(element);

    if (new_element == EL_AMOEBE_TOT && level.amoeba_speed)
      new_element = EL_AMOEBE_NASS;

    if (new_element == EL_UNKNOWN_EL)
    {
      printf("----------> Oops! [%d][%d]: element 0x%02x unknown!\n",
	     x,y,element);

      new_element = EL_CHAR_FRAGE;
    }
    else if (new_element >= EL_FIRST_RUNTIME_EL)
    {
      printf("----------> Oops! GOT RUNTIME ELEMENT! SHOULD NEVER HAPPEN!\n");

      new_element = EL_CHAR_FRAGE;
    }

    Ur[x][y] = new_element;
  }

  JX = (header[48]*256+header[49]) % 64;
  JY = (header[48]*256+header[49]) / 64;
  Ur[JX][JY] = EL_SPIELER1;

  JX = (header[50]*256+header[51]) % 64;
  JY = (header[50]*256+header[51]) / 64;
  Ur[JX][JY] = EL_SPIELER2;
}


#define BYTE_ORDER_BIG_ENDIAN		0
#define BYTE_ORDER_LITTLE_ENDIAN	1

void putFile16BitInteger(FILE *file, short value, int byte_order)
{
  if (byte_order == BYTE_ORDER_BIG_ENDIAN)
  {
    fputc((value >>  8) & 0xff, file);
    fputc((value >>  0) & 0xff, file);
  }
  else		 /* BYTE_ORDER_LITTLE_ENDIAN */
  {
    fputc((value >>  0) & 0xff, file);
    fputc((value >>  8) & 0xff, file);
  }
}

void putFileChunk(FILE *file, char *chunk_name, int chunk_length,
		  int byte_order)
{
  fputs(chunk_name, file);

  if (byte_order == BYTE_ORDER_BIG_ENDIAN)
  {
    fputc((chunk_length >> 24) & 0xff, file);
    fputc((chunk_length >> 16) & 0xff, file);
    fputc((chunk_length >>  8) & 0xff, file);
    fputc((chunk_length >>  0) & 0xff, file);
  }
  else		 /* BYTE_ORDER_LITTLE_ENDIAN */
  {
    fputc((chunk_length >>  0) & 0xff, file);
    fputc((chunk_length >>  8) & 0xff, file);
    fputc((chunk_length >> 16) & 0xff, file);
    fputc((chunk_length >> 24) & 0xff, file);
  }
}


#define LEVEL_HEADER_SIZE	80	/* size of level file header */
#define LEVEL_HEADER_UNUSED	15	/* unused level header bytes */

/* file identifier strings */
#define LEVEL_COOKIE_12		"ROCKSNDIAMONDS_LEVEL_FILE_VERSION_1.2"
#define LEVEL_COOKIE		"ROCKSNDIAMONDS_LEVEL_FILE_VERSION_1.4"

/* file permissions for newly written files */
#define MODE_R_ALL		(S_IRUSR | S_IRGRP | S_IROTH)
#define MODE_W_ALL		(S_IWUSR | S_IWGRP | S_IWOTH)
#define MODE_X_ALL		(S_IXUSR | S_IXGRP | S_IXOTH)
#define LEVEL_PERMS		(MODE_R_ALL | MODE_W_ALL)

#if 0
void SaveNewLevel(int level_nr, char *level_dir)
{
  int i,x,y;
  char filename[256];
  FILE *file;

  sprintf(filename,"%s/%03d.level", level_dir, level_nr);

  printf("|  Writing '%s'\n", filename);

  if (!(file=fopen(filename,"w")))
  {
    fprintf(stderr,"%s: cannot save level %d!\n",
	    progname,level_nr);
    return;
  }

  fprintf(file,"%s\n",LEVEL_COOKIE);	/* Formatkennung */

  fputc(level.fieldx,file);
  fputc(level.fieldy,file);
  fputc(level.time / 256,file);
  fputc(level.time % 256,file);
  fputc(level.gems_needed / 256,file);
  fputc(level.gems_needed % 256,file);

  for(i=0;i<MAX_LEVEL_NAME_LEN;i++)
    fputc(level.name[i],file);
  for(i=0;i<LEVEL_SCORE_ELEMENTS;i++)
    fputc(level.score[i],file);
  for(i=0;i<4;i++)
    for(y=0;y<3;y++)
      for(x=0;x<3;x++)
	fputc(level.yam_content[i][x][y],file);
  fputc(level.amoeba_speed,file);
  fputc(level.time_magic_wall,file);
  fputc(level.time_wheel,file);
  fputc(level.amoeba_content,file);

  for(i=0;i<NUM_FREE_LVHD_BYTES;i++)	/* Rest frei / Headergre 80 Bytes */
    fputc(0,file);

  for(y=0;y<32;y++) 
    for(x=0;x<64;x++) 
      fputc(Ur[x][y],file);

  fclose(file);
}
#endif

void SaveLevel(char *filename)
{
  int i, x, y;
  boolean encoding_16bit = FALSE;	/* default: maximal 256 elements */
  char *oldest_possible_cookie;
  FILE *file;

  if (!(file = fopen(filename, "w")))
  {
    fprintf(stderr, "%s: cannot save level file '%s'\n", progname, filename);
    exit(1);
  }

  /* check yam content for 16-bit elements */
  for(i=0; i<MAX_ELEMENT_CONTENTS; i++)
    for(y=0; y<3; y++)
      for(x=0; x<3; x++)
	if (level.yam_content[i][x][y] > 255)
	  encoding_16bit = TRUE;

  /* check level field for 16-bit elements */
  for(y=0; y<lev_fieldy; y++) 
    for(x=0; x<lev_fieldx; x++) 
      if (Ur[x][y] > 255)
	encoding_16bit = TRUE;

  oldest_possible_cookie = (encoding_16bit ? LEVEL_COOKIE : LEVEL_COOKIE_12);

  fputs(oldest_possible_cookie, file);		/* file identifier */
  fputc('\n', file);

  putFileChunk(file, "HEAD", LEVEL_HEADER_SIZE, BYTE_ORDER_BIG_ENDIAN);

  fputc(level.fieldx, file);
  fputc(level.fieldy, file);

  putFile16BitInteger(file, level.time, BYTE_ORDER_BIG_ENDIAN);
  putFile16BitInteger(file, level.gems_needed, BYTE_ORDER_BIG_ENDIAN);

  for(i=0; i<MAX_LEVEL_NAME_LEN; i++)
    fputc(level.name[i], file);
  for(i=0; i<LEVEL_SCORE_ELEMENTS; i++)
    fputc(level.score[i], file);
  for(i=0; i<STD_ELEMENT_CONTENTS; i++)
    for(y=0; y<3; y++)
      for(x=0; x<3; x++)
	fputc(encoding_16bit ? EL_LEERRAUM : level.yam_content[i][x][y], file);
  fputc(level.amoeba_speed, file);
  fputc(level.time_magic_wall, file);
  fputc(level.time_wheel, file);
  fputc(level.amoeba_content, file);
  fputc((level.double_speed ? 1 : 0), file);
  fputc((level.gravity ? 1 : 0), file);

  fputc((encoding_16bit ? 1 : 0), file);

  for(i=0; i<LEVEL_HEADER_UNUSED; i++)	/* set unused header bytes to zero */
    fputc(0, file);

  putFileChunk(file, "CONT", 4 + MAX_ELEMENT_CONTENTS * 3 * 3,
	       BYTE_ORDER_BIG_ENDIAN);

  fputc(EL_MAMPFER, file);
  fputc(level.num_yam_contents, file);
  fputc(0, file);
  fputc(0, file);

  for(i=0; i<MAX_ELEMENT_CONTENTS; i++)
    for(y=0; y<3; y++)
      for(x=0; x<3; x++)
	if (encoding_16bit)
	  putFile16BitInteger(file, level.yam_content[i][x][y],
			      BYTE_ORDER_BIG_ENDIAN);
	else
	  fputc(level.yam_content[i][x][y], file);

  putFileChunk(file, "BODY", lev_fieldx * lev_fieldy, BYTE_ORDER_BIG_ENDIAN);

  for(y=0; y<lev_fieldy; y++) 
    for(x=0; x<lev_fieldx; x++) 
      if (encoding_16bit)
	putFile16BitInteger(file, Ur[x][y], BYTE_ORDER_BIG_ENDIAN);
      else
	fputc(Ur[x][y], file);

  fclose(file);

  chmod(filename, LEVEL_PERMS);
}

static void setLevelInfoToDefaults()
{
  int i, x, y;

  lev_fieldx = level.fieldx = STD_LEV_FIELDX;
  lev_fieldy = level.fieldy = STD_LEV_FIELDY;

  for(x=0; x<MAX_LEV_FIELDX; x++)
    for(y=0; y<MAX_LEV_FIELDY; y++)
      Ur[x][y] = EL_ERDREICH;

  level.time = 100;
  level.gems_needed = 0;
  level.amoeba_speed = 10;
  level.time_magic_wall = 10;
  level.time_wheel = 10;
  level.time_light = 10;
  level.time_timegate = 10;
  level.amoeba_content = EL_DIAMANT;
  level.double_speed = FALSE;
  level.gravity = FALSE;

  for(i=0; i<MAX_LEVEL_NAME_LEN; i++)
    level.name[i] = '\0';
  for(i=0; i<MAX_LEVEL_AUTHOR_LEN; i++)
    level.author[i] = '\0';

  strcpy(level.name, NAMELESS_LEVEL_NAME);
  strcpy(level.author, ANONYMOUS_NAME);

  for(i=0; i<LEVEL_SCORE_ELEMENTS; i++)
    level.score[i] = 10;

  level.num_yam_contents = STD_ELEMENT_CONTENTS;
  for(i=0; i<MAX_ELEMENT_CONTENTS; i++)
    for(x=0; x<3; x++)
      for(y=0; y<3; y++)
	level.yam_content[i][x][y] = EL_FELSBROCKEN;

  Ur[0][0] = EL_SPIELFIGUR;
  Ur[STD_LEV_FIELDX-1][STD_LEV_FIELDY-1] = EL_AUSGANG_ZU;
}

void main(int argc, char *argv[])
{
  int level_nr = 0;
  int num_levels = -1;
  int valid_level = TRUE;
  char *leveldir_old, *leveldir_new;

  progname = argv[0];

  if (argc < 3 || argc > 4)
  {
    printf("Usage: %s <emerald mine level dir> <new level dir> [num levels]\n",
	   progname);
    exit(0);
  }

  leveldir_old = argv[1];
  leveldir_new = argv[2];

  if (argc == 4)
    num_levels = atoi(argv[3]);

  while (valid_level || (num_levels != -1 && level_nr < num_levels))
  {
    char filename_old[256];
    char filename_new[256];

    sprintf(filename_old, "%s/%d", leveldir_old, level_nr);
    sprintf(filename_new, "%s/%03d.level", leveldir_new, level_nr);

    if ((valid_level = (access(filename_old, R_OK) == 0)))
    {
      printf("|  Converting level %d...\n", level_nr);
      LoadEmeraldMineLevel(filename_old, level_nr);

      printf("|  Writing '%s'\n", filename_new);
      SaveLevel(filename_new);
    }

    if (level_nr < 100)		/* check at least the first 100 levels */
      valid_level = TRUE;

    level_nr++;
  }
}
